//#include <windows.h>
#include <stdio.h>
#include <unistd.h> 

static int asw_currentstream = 0;
static int asw_streams = 0;
static int asw_streamid[16];
static int asw_streamcodec[16];
static int asw_streamptr[16];

static int asw_coremovie_handle;
static int asw_mediainfo;
static int asw_helper;
static char asw_filename[256];

static FILE *asw_logfile;
char asw_config[512];

static int u7, u8, u9;

static int asw_logs( char *str ) __attribute__ ((noinline));
static int asw_logs( char *str )
{
	return 0;

	if ( !asw_logfile )
	{
		char	fname[256];

		strcpy( fname, asw_config );
		*strchr( fname, '.' ) = 0;
		strcat( fname, ".log" );

		asw_logfile = fopen( fname, "a+" );
	}

	if ( asw_logfile )
	{
		fputs( str, asw_logfile );
		fflush( asw_logfile );
	}

	return 0;
}

static int asw_logi( unsigned i ) __attribute__ ((noinline));
static int asw_logi( unsigned i )
{
	if ( asw_logfile )
	{
		char	str[32];

		sprintf( str, "0x%08X", i );
		asw_logs( str );
	}

	return 0;
}

static int asw_process_keyproc( int key ) __attribute__ ((noinline));
static int asw_process_keyproc( int key )
{
	if( key == 0x6C && asw_streams ) 	// red button
	{
		asw_currentstream++;

		if ( asw_currentstream >= asw_streams )
		{
			asw_logs( "returning to the first stream..\n" );
			asw_currentstream = 0;
		}

		if ( asw_streamid[asw_currentstream] )
		{
			asw_logs( "changing stream to " );
			asw_logi( asw_currentstream );
			asw_logs( " / audio stream id:  " );
			asw_logi( asw_streamid[asw_currentstream] );
			asw_logs( " / audio codec: " );
			asw_logi( asw_streamcodec[asw_currentstream] );
			asw_logs( "\n" );

			spIAvfd_ChangeAudio( 0, asw_streamid[asw_currentstream], asw_streamcodec[asw_currentstream] );
		}
	}

	return key;
}

static int asw_process_mediatype() __attribute__ ((noinline));
static int asw_process_mediatype()
{
	asw_logs( "u7: " );
	asw_logi( u7 );
	asw_logs( "\n" );

	asw_logs( "streamtype: " );
	asw_logi( ((unsigned *)u7)[0x238/4] );
	asw_logs( "\n" );

	asw_logs( "codectype: " );
	asw_logi( u8 );
	asw_logs( "\n" );

	asw_logs( "streamid: " );
	asw_logi( u9 );
	asw_logs( "\n" );

	u8 = _ZN10CMovieCore15AudioFormatToTDEN10Multimedia14AudioCodecTypeE( 0, u8 );

	u8 = _ZN10CFeeder_CH29locConvertSdalToAvfdAudFormatE15SdAudioFormat_k( 0, u8 );

	asw_logs( "codectype after convert: " );
	asw_logi( u8 );
	asw_logs( "\n" );

	if ( u8 == 8 )
	{
		// unsupported audio, ignore stream
		((unsigned *)u7)[0x238/4] = 0;
		((unsigned *)u7)[0x23C/4] = 0;
	}
	else
	{
		asw_streamcodec[asw_streams] = u8;
		asw_streamid[asw_streams] = u9;
		asw_streamptr[asw_streams] = u7;
		asw_streams++;
	}

	return 0;
}

static int asw_process_filemoviecore() __attribute__ ((noinline));
static int asw_process_filemoviecore()
{
	asw_logs( "movie stopped..\n" );
	asw_streams = 0;

	return 0;
}

static int asw_process_mediainfo() __attribute__ ((noinline));
static int asw_process_mediainfo()
{
	unsigned i, *ptr;

	asw_logs( "coremovie: " );
	asw_logi( u7 );
	asw_logs( "\n" );

	asw_logs( "mediainfo: " );
	asw_logi( u9 );
	asw_logs( "\n" );

	asw_logs( "mediainfo: " );
	asw_logs( (char *)u8 );
	asw_logs( "\n" );

	asw_coremovie_handle = u7;
	asw_mediainfo = u9;
	asw_helper = u8;

	if ( !strcmp( asw_filename, (char *)asw_helper ) )
	{
		asw_logs( "same movie, preparing for setting previous current stream..\n" );
		for( i = 0; i < asw_currentstream; i++ )
		{
			// reset all streams till current stream..
			ptr = asw_streamptr[i];
			
			ptr[0x238/4] = 0;
			ptr[0x23C/4] = 0;
		}
	}
	else
	{
		asw_logs( "new movie, resetting current stream..\n" );
		asw_currentstream = 0;
		strcpy(	asw_filename, asw_helper );
	}

	return 0;
}

void *asw_keyproc_injection( int a, int key ) __attribute__ ((noinline));
void *asw_keyproc_injection( int a, int key )
{
	asm volatile(
		"STMFD   SP!, {R0,R2,R3,R12}\n");

	asw_process_keyproc( key );

	asm volatile(
		"MOV     R1, R0\n" // remapped keycode
		"MOV     R6, R0\n" // remapped keycode
		"LDMFD   SP!, {R0,R2,R3,R12}\n"
		"LDMFD   SP!, {R4,LR}\n"
		"MOV     R7, R2\n"  //This is original command that we overwrite
		"LDR     R3, [R8]\n"  //This is original command that we overwrite
		"LDR     PC, =(_ZN9KeyCommon17SendKeyPressInputEii + 0x18 )\n"	//return after injection
	);
}

void *asw_mediatype_injection() __attribute__ ((noinline));
void *asw_mediatype_injection()
{
	// it's better to use labels, so we can ignore GCC stack instructions
	asm volatile(	
			".global asw_mediatype_injection_lbl\n"
			"asw_mediatype_injection_lbl:\n"
			"STMFD   SP!, {R0-R12,LR}\n" //Put all General Purpose registers to Stack
			"SUB     SP,  SP, #56\n"  
			"LDR	 R8, [R7,#0x288]\n"
			"ADD	 R9, R6, #0x1\n"  
	);

	asm volatile(
		"MOV	r5,%0\n"
		"STR 	r7,[r5]\n"
		"MOV	r5,%1\n"
		"STR 	r8,[r5]\n"
		"MOV	r5,%2\n"
		"STR 	r9,[r5]\n"
		:
		: "r" (&u7), "r" (&u8), "r" (&u9) );

	asw_process_mediatype();

	asm volatile(
		"ADD     SP, SP, #56\n"
		"LDMFD   SP!, {R0-R12,LR}\n"// Restore all GP registers from Stack
		"ADD     R3, R4, R5\n"		// old replaced instructions
		"LDR     R2, [R3,#0x18]\n"
		"LDR     PC, =(_ZN13CParsingMedia16GetMediaTypeInfoEPKcPN10Multimedia18_tMediaInfoContextE+0x334)\n" );
}

void *asw_filemoviecore_injection() __attribute__ ((noinline));
void *asw_filemoviecore_injection()
{
	// it's better to use labels, so we can ignore GCC stack instructions
	asm volatile(	
			".global asw_filemoviecore_injection_lbl\n"
			"asw_filemoviecore_injection_lbl:\n"
			"STMFD   SP!, {R0-R12,LR}\n" //Put all General Purpose registers to Stack
			"SUB     SP,  SP, #56\n"  
	);

	asw_process_filemoviecore();

	asm volatile(
		"ADD     SP, SP, #56\n"
		"LDMFD   SP!, {R0-R12,LR}\n"// Restore all GP registers from Stack
		"MOV     R4, R0\n"		// old replaced instructions
		"SUB     SP, SP, #0xC\n"
		"LDR     PC, =(_ZN14CFileMovieCore4StopEv+0xC)\n" );
}

void *asw_movieplay_injection() __attribute__ ((noinline));
void *asw_movieplay_injection()
{
	// it's better to use labels, so we can ignore GCC stack instructions
	asm volatile(	
			".global asw_movieplay_injection_lbl\n"
			"asw_movieplay_injection_lbl:\n"
			"STMFD   SP!, {R0-R12,LR}\n" //Put all General Purpose registers to Stack
			"SUB     SP,  SP, #56\n"
	);

	asm volatile(
		"MOV	R10,%0\n"
		"STR 	R10,[R5,#0xDB0]\n"
		:
		: "r" (asw_streamid[asw_currentstream]) );

	asw_logs( "setting current stream to: " );
	asw_logi( asw_streamid[asw_currentstream] );
	asw_logs( "\n" );

	asm volatile(
		"ADD     SP, SP, #56\n"
		"LDMFD   SP!, {R0-R12,LR}\n"// Restore all GP registers from Stack
		"LDR     R2, [R5,#8]\n"		// old replaced instructions
		"LDR     R1, [R5,#0xDC0]\n"
		"LDR     PC, =(_ZN10Multimedia11MediaPlayer5Movie10CFileMovie4PlayExPhPN11MediaCommon8DRM_INFOE+0x118)\n" );
}

void *asw_mediainfo_injection() __attribute__ ((noinline));
void *asw_mediainfo_injection()
{
	// it's better to use labels, so we can ignore GCC stack instructions
	asm volatile(	
			".global asw_mediainfo_injection_lbl\n"
			"asw_mediainfo_injection_lbl:\n"
			"STMFD   SP!, {R0-R12,LR}\n" //Put all General Purpose registers to Stack
			"SUB     SP,  SP, #56\n"
			"MOV	 R7, R0\n"
			"MOV	 R8, R1\n"  
			"MOV	 R9, R2\n"  
	);

	asm volatile(
		"MOV	r5,%0\n"
		"STR 	r7,[r5]\n"
		"MOV	r5,%1\n"
		"STR 	r8,[r5]\n"
		"MOV	r5,%2\n"
		"STR 	r9,[r5]\n"
		:
		: "r" (&u7), "r" (&u8), "r" (&u9) );

	asw_process_mediainfo();

	asm volatile(
		"ADD     SP, SP, #56\n"
		"LDMFD   SP!, {R0-R12,LR}\n"// Restore all GP registers from Stack
		"MOV     R5, R0\n"		// old replaced instructions
		"MOV     R7, R1\n"
		"LDR     PC, =(_ZN14CFileMovieCore4OpenEPcPN10Multimedia18_tMediaInfoContextE+0x5*4)\n" );
}

