#include <stdio.h>
#include <dlfcn.h>
#include <errno.h>
#include <sys/mman.h>

#include <string.h>

FILE 	*loader_logfile = NULL;

void loader_logs( char *str )
{
	if ( loader_logfile )
	{
		fputs( str, loader_logfile );
		fflush( loader_logfile );
	}
}

void loader_logi( unsigned i )
{
	if ( loader_logfile )
	{
		char	str[32];

		sprintf( str, "0x%08X", i );
		loader_logs( str );
	}
}

static void cacheflush(void *start, size_t size)
{
   /* For details, please see the Linux sources, files
    * arch/arm/kernel/traps.c, arch/arm/kernel/entry-common.S and
    * asm-arm/unistd.h
    *
    * This syscall is supported by all 2.4 and 2.6 Linux kernels.  2.2 linux
    * kernels got first support with version 2.2.18.
    */

   asm("mov r0, %0\n"
       "mov r1, %1\n"
       "mov r2, #0\n"
       /* EABI or Thumb syscall: syscall number passed in 'r7' (syscall base
	* number is 0x0).  Note that Thumb and EABI are generally not the
	* same.  It just happens that the simple cacheflush syscall doesn't
	* expose any of differences in calling conventions.
        */
       "mov r7, #0xf0000\n"
       "add r7, #0x02\n"
       "swi #0\n" ::
       "g"(start), "g"((long)start+size) :
       "r0", "r1", "r2", "r7");
}

void injector( const char *path )
{
	unsigned *handle=NULL;

	if ( (handle = dlopen(NULL,RTLD_LAZY | RTLD_GLOBAL)) == NULL )
	{
		loader_logs( "Cannot open self!\n" );
		loader_logs( dlerror() );
		return;
	}

	unsigned *CParsingMedia_GetMediaTypeInfo = dlsym(handle,"_ZN13CParsingMedia16GetMediaTypeInfoEPKcPN10Multimedia18_tMediaInfoContextE");
	unsigned *KeyCommon_SendKeyPressInput = dlsym(handle,"_ZN9KeyCommon17SendKeyPressInputEii");
	unsigned *CFileMovieCore_stop = dlsym(handle,"_ZN14CFileMovieCore4StopEv");
	unsigned *CMovieCore_Open = dlsym(handle,"_ZN14CFileMovieCore4OpenEPcPN10Multimedia18_tMediaInfoContextE");
	unsigned *Movie_Play = dlsym(handle,"_ZN10Multimedia11MediaPlayer5Movie10CFileMovie4PlayExPhPN11MediaCommon8DRM_INFOE" );

	if(CParsingMedia_GetMediaTypeInfo == NULL )
	{
		loader_logs("cannot find _ZN13CParsingMedia16GetMediaTypeInfoEPKcPN10Multimedia18_tMediaInfoContextE functions!\n");
		loader_logs(dlerror());
		loader_logs("\n");
		return;
	}

	if(KeyCommon_SendKeyPressInput == NULL )
	{
		loader_logs("Cannot find _ZN9KeyCommon17SendKeyPressInputEii functions!\n");
		loader_logs(dlerror());
		loader_logs("\n");
		return;
	}

	if(CFileMovieCore_stop == NULL )
	{
		loader_logs("Cannot find _ZN14CFileMovieCore4StopEv functions!\n");
		loader_logs(dlerror());
		loader_logs("\n");
		return;
	}

	if(CMovieCore_Open == NULL )
	{
		loader_logs("Cannot find _ZN14CFileMovieCore4OpenEPcPN10Multimedia18_tMediaInfoContextE functions!\n");
		loader_logs(dlerror());
		loader_logs("\n");
		return;
	}

	if(Movie_Play == NULL )
	{
		loader_logs("Cannot find _ZN10Multimedia11MediaPlayer5Movie10CFileMovie4PlayExPhPN11MediaCommon8DRM_INFOE functions!\n");
		loader_logs(dlerror());
		loader_logs("\n");
		return;
	}

	dlclose(handle);

	/* Load the library */
	char filename[256];

	strcpy(filename, path);
	strcat(filename, "switch.so");

	if ( (handle = dlopen( filename, RTLD_NOW | RTLD_LOCAL | RTLD_NODELETE)) == NULL )
	{
		loader_logs("cannot open switch_inj.so!\n");
		loader_logs (dlerror());
		loader_logs("\n");
		return;
	}

	unsigned *asw_keyproc_injectionx = dlsym( handle, "asw_keyproc_injection" );
	unsigned *asw_mediatype_injection_lblx = dlsym( handle, "asw_mediatype_injection_lbl" );
	unsigned *asw_filemoviecore_injection_lblx = dlsym( handle, "asw_filemoviecore_injection_lbl" );
	unsigned *asw_mediainfo_injection_lblx = dlsym( handle, "asw_mediainfo_injection_lbl" );
	unsigned *asw_movieplay_injection_lblx = dlsym( handle, "asw_movieplay_injection_lbl" );

	char *asw_configx = dlsym( handle, "asw_config" );

	if ( asw_configx )
	{
		strcpy( asw_configx, path );
		strcat( asw_configx, "switch.cfg" );	// cfg file not used..
	}
	else
	{
		loader_logs( "asw_config NOT found..\n" );
		return;
	}

	if ( !asw_movieplay_injection_lblx )
	{
		loader_logs( "asw_movieplay_injection NOT found..\n" );
		return;
	}

	if ( !asw_keyproc_injectionx )
	{
		loader_logs( "asw_keyproc_injection NOT found..\n" );
		return;
	}

	if ( !asw_mediatype_injection_lblx )
	{
		loader_logs( "asw_mediatype_injection_lbl NOT found..\n" );
		return;
	}

	if ( !asw_filemoviecore_injection_lblx )
	{
		loader_logs( "asw_filemoviecore_injection_lbl NOT found..\n" );
		return;
	}

	if ( !asw_mediainfo_injection_lblx )
	{
		loader_logs( "asw_mediainfo_injection_lbl NOT found..\n" );
		return;
	}

	dlclose(handle);

	int page;

	// injections
 	page = ((unsigned) KeyCommon_SendKeyPressInput) & ~0x0FFF;
	mprotect((void *) page, 8192, PROT_READ | PROT_WRITE | PROT_EXEC);
	KeyCommon_SendKeyPressInput[4]=0xE51FF004;
	KeyCommon_SendKeyPressInput[5]=(unsigned) asw_keyproc_injectionx;	// to control red button on the remote
	mprotect((void *) page, 8192, PROT_READ | PROT_EXEC);

 	page = ((unsigned) CParsingMedia_GetMediaTypeInfo) & ~0x0FFF;
	mprotect((void *) page, 8192, PROT_READ | PROT_WRITE | PROT_EXEC);
	CParsingMedia_GetMediaTypeInfo[0xCB]=0xE51FF004;
	CParsingMedia_GetMediaTypeInfo[0xCC]=(unsigned) asw_mediatype_injection_lblx;	// to load all stream ids and codecs, ignore unsupported
	mprotect((void *) page, 8192, PROT_READ | PROT_EXEC);

 	page = ((unsigned) CFileMovieCore_stop) & ~0x0FFF;
	mprotect((void *) page, 8192, PROT_READ | PROT_WRITE | PROT_EXEC);
	CFileMovieCore_stop[0x1]=0xE51FF004;
	CFileMovieCore_stop[0x2]=(unsigned) asw_filemoviecore_injection_lblx;			// to clear stream ids and codecs
	mprotect((void *) page, 8192, PROT_READ | PROT_EXEC);

	page = ((unsigned) CMovieCore_Open) & ~0x0FFF;
	mprotect((void *) page, 8192, PROT_READ | PROT_WRITE | PROT_EXEC);
	CMovieCore_Open[0x3]=0xE51FF004;
	CMovieCore_Open[0x4]=(unsigned) asw_mediainfo_injection_lblx;			// to clear stream ids and codecs
	mprotect((void *) page, 8192, PROT_READ | PROT_EXEC);

	page = ((unsigned) Movie_Play) & ~0x0FFF;
	mprotect((void *) page, 8192, PROT_READ | PROT_WRITE | PROT_EXEC);
	Movie_Play[0xFC/4+5]=0xE51FF004;
	Movie_Play[0xFC/4+6]=(unsigned) asw_movieplay_injection_lblx;
	mprotect((void *) page, 8192, PROT_READ | PROT_EXEC);

	// flush
	cacheflush(KeyCommon_SendKeyPressInput+0x4, 8);
	cacheflush(CParsingMedia_GetMediaTypeInfo+0xCB, 8);
	cacheflush(CFileMovieCore_stop+0x1, 8);
	cacheflush(CMovieCore_Open+0x3, 8);
	cacheflush(Movie_Play+0xFC/4+5, 8);
}

int Game_Main(const char  *path, const char *udn __attribute__ ((unused)))
{
	char szlogfile[256];

	strcpy( szlogfile, path );
	strcat( szlogfile, "loader.log" );
	
//	remove( szlogfile );
	
//	loader_logfile = fopen( szlogfile,"a+" );

	injector( path );

	if ( loader_logfile ) fclose( loader_logfile );

	return 1;
}
